// ======================= Atmega128 ؽƮ Touch α׷ ====================
//  CPU : ATmega128-16M - ؽƮ TSC2003(ġ Ʈѷ)
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */






/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// Լ 
void main_menu_disp(void);						//  ޴ ǥ
int Touch_Data(int scan_time);						// ġ  
void TSC2003_Setup(void);						// I2c ʱȭ TSC2003ʱȭ
void TSC2003_Write(unsigned char  byte);				// TSC2003 ġ Write
unsigned TSC2003_Word_Read(unsigned char cmd);				// TSC2003 ġ Word Read

//  
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
int timer0_touch_cnt = 0;					// timer0 ġ  10ms ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg             
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : LCD_CS1
// PortC.1 : LCD_CS2
	PORTC=0xfc;						// Ʈ  reg             
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external) 
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	(*(unsigned char *) 0x65)=0x07;						// Ʈ  reg             
	(*(unsigned char *) 0x64)=0x07;                                              // Ʈ  reg(0Է,1)
	
// Timer/Counter0 
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	(*(unsigned char *) 0x7d)=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	(*(unsigned char *) 0x95)=0x06;
	(*(unsigned char *) 0x90)=0x00;
	UBRR0L=0x33;

// External SRAM page configuration: 
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [19] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [17] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_touch_cnt++;					// Ÿ̸0 ġ  ī++
}

//  
int Touch_X = 0,Touch_Y = 0;						// ġ ġ  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpu ʱȭ
	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	main_menu_disp();						//  ޴ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		if(Touch_Data(2)){					// ġ  ˻ 20ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("======= TSC2003 Touch Test =======\r\n");
	printf("- press any touch screen         -\r\n");
	printf("----------------------------------\r\n");
}

// ========================== ġκ ͸  =======================
// [μ] int scan_time
// Item1: ġ SCAN Timne(scan_time * 10ms)
// [] 1( ȿ),0( )
// [] Touch_X,Touch_Y : ġ  
// ---------------------------------------------------------------------------
int Touch_Data(int scan_time)
{
	if((PINE&0x80) == 0){						// ġ ?
		if(timer0_touch_cnt >= scan_time){			// ġ  üũ Ÿ scan_time*10ms
			Touch_X = TSC2003_Word_Read(0xcc);		// X  / 12bit / ADC ON
			Touch_Y = TSC2003_Word_Read(0xdc);		// Y  / 12bit / ADC ON
			TSC2003_Write(0x38);				// PENIRQ ready mode
			timer0_touch_cnt = 0;				// timer clear
			return(1);
		}
	}
	else timer0_touch_cnt = 0;					//  
	return(0);
}

// ================================ TSC2003 Setup ============================
// [μ] void
// ---------------------------------------------------------------------------
void TSC2003_Setup(void)
{
// TWI(I2c) setup
	(*(unsigned char *) 0x70) = 0x0c;							// Bit Rate: 400.000 kHz
	(*(unsigned char *) 0x73) = 0xff;							// TWI DATA = 0xff
	(*(unsigned char *) 0x71) = 0x00;							//  Clear , prescaler = 00(1)

// TSC2003 setup
	TSC2003_Write(0x38);						// PENIRQ ready mode
}

// ================================ TSC2003 Write ============================
// [μ] unsigned char datau
// Item1:  
// ---------------------------------------------------------------------------
void TSC2003_Write(unsigned char datau)
{
	(*(unsigned char *) 0x74) = 0xa4;							// START
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x08));	
	(*(unsigned char *) 0x73) = 0x90;							// Address 0 + write
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x18));	
	(*(unsigned char *) 0x73) = datau;							// data ۽
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x28));

	(*(unsigned char *) 0x74) = 0x94;							// Ϸ 
}

// =============================== TSC2003 word Read =========================
// [μ] unsigned char cmd
// Item1: ġ  command 
// ---------------------------------------------------------------------------
unsigned TSC2003_Word_Read(unsigned char cmd)
{
unsigned char byte;
unsigned rdatau = 0;

	(*(unsigned char *) 0x74) = 0xa4;							// START
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x08));	
	(*(unsigned char *) 0x73) = 0x90;							// Address 0 + write
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x18));	
	(*(unsigned char *) 0x73) = cmd;							// cmd data ۽
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x28));
  
	(*(unsigned char *) 0x74) = 0xa4;							// START
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x10));	//  ?
	(*(unsigned char *) 0x73) = 0x91;   							// Address 0 + read   
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ    
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x40));	// SLA-R Ϸ?
	(*(unsigned char *) 0x74) = 0xc4;							// data read
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x50));	// data  ACK?
	rdatau = (*(unsigned char *) 0x73);
	(*(unsigned char *) 0x74) = 0x84;							// TWINT 1 Ἥ Ŭ    
	while((((*(unsigned char *) 0x74) & 0x80) == 0x00) || (((*(unsigned char *) 0x71) & 0xf8) != 0x58));	// data  ACK?
	byte = (*(unsigned char *) 0x73);

	(*(unsigned char *) 0x74) = 0x94;							// Ϸ           	

	rdatau =  (rdatau << 4) & 0x0ff0;				// D11-D4
	rdatau |= (unsigned)((byte >> 4) & 0x0f);			// D3-D0	

	return rdatau;
}
